// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Gphdt.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/gphdt__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `message_id`
// Member `t`
#include "rosidl_runtime_c/string_functions.h"

bool
novatel_gps_msgs__msg__Gphdt__init(novatel_gps_msgs__msg__Gphdt * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Gphdt__fini(msg);
    return false;
  }
  // message_id
  if (!rosidl_runtime_c__String__init(&msg->message_id)) {
    novatel_gps_msgs__msg__Gphdt__fini(msg);
    return false;
  }
  // heading
  // t
  if (!rosidl_runtime_c__String__init(&msg->t)) {
    novatel_gps_msgs__msg__Gphdt__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__Gphdt__fini(novatel_gps_msgs__msg__Gphdt * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // message_id
  rosidl_runtime_c__String__fini(&msg->message_id);
  // heading
  // t
  rosidl_runtime_c__String__fini(&msg->t);
}

bool
novatel_gps_msgs__msg__Gphdt__are_equal(const novatel_gps_msgs__msg__Gphdt * lhs, const novatel_gps_msgs__msg__Gphdt * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // message_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message_id), &(rhs->message_id)))
  {
    return false;
  }
  // heading
  if (lhs->heading != rhs->heading) {
    return false;
  }
  // t
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->t), &(rhs->t)))
  {
    return false;
  }
  return true;
}

bool
novatel_gps_msgs__msg__Gphdt__copy(
  const novatel_gps_msgs__msg__Gphdt * input,
  novatel_gps_msgs__msg__Gphdt * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // message_id
  if (!rosidl_runtime_c__String__copy(
      &(input->message_id), &(output->message_id)))
  {
    return false;
  }
  // heading
  output->heading = input->heading;
  // t
  if (!rosidl_runtime_c__String__copy(
      &(input->t), &(output->t)))
  {
    return false;
  }
  return true;
}

novatel_gps_msgs__msg__Gphdt *
novatel_gps_msgs__msg__Gphdt__create()
{
  novatel_gps_msgs__msg__Gphdt * msg = (novatel_gps_msgs__msg__Gphdt *)malloc(sizeof(novatel_gps_msgs__msg__Gphdt));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Gphdt));
  bool success = novatel_gps_msgs__msg__Gphdt__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Gphdt__destroy(novatel_gps_msgs__msg__Gphdt * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Gphdt__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Gphdt__Sequence__init(novatel_gps_msgs__msg__Gphdt__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Gphdt * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Gphdt *)calloc(size, sizeof(novatel_gps_msgs__msg__Gphdt));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Gphdt__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Gphdt__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Gphdt__Sequence__fini(novatel_gps_msgs__msg__Gphdt__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Gphdt__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Gphdt__Sequence *
novatel_gps_msgs__msg__Gphdt__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Gphdt__Sequence * array = (novatel_gps_msgs__msg__Gphdt__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Gphdt__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Gphdt__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Gphdt__Sequence__destroy(novatel_gps_msgs__msg__Gphdt__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Gphdt__Sequence__fini(array);
  }
  free(array);
}

bool
novatel_gps_msgs__msg__Gphdt__Sequence__are_equal(const novatel_gps_msgs__msg__Gphdt__Sequence * lhs, const novatel_gps_msgs__msg__Gphdt__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!novatel_gps_msgs__msg__Gphdt__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
novatel_gps_msgs__msg__Gphdt__Sequence__copy(
  const novatel_gps_msgs__msg__Gphdt__Sequence * input,
  novatel_gps_msgs__msg__Gphdt__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(novatel_gps_msgs__msg__Gphdt);
    novatel_gps_msgs__msg__Gphdt * data =
      (novatel_gps_msgs__msg__Gphdt *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!novatel_gps_msgs__msg__Gphdt__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          novatel_gps_msgs__msg__Gphdt__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!novatel_gps_msgs__msg__Gphdt__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
