// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/Range.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/range__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `novatel_msg_header`
#include "novatel_gps_msgs/msg/detail/novatel_message_header__functions.h"
// Member `info`
#include "novatel_gps_msgs/msg/detail/range_information__functions.h"

bool
novatel_gps_msgs__msg__Range__init(novatel_gps_msgs__msg__Range * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__Range__fini(msg);
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&msg->novatel_msg_header)) {
    novatel_gps_msgs__msg__Range__fini(msg);
    return false;
  }
  // numb_of_observ
  // info
  if (!novatel_gps_msgs__msg__RangeInformation__Sequence__init(&msg->info, 0)) {
    novatel_gps_msgs__msg__Range__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__Range__fini(novatel_gps_msgs__msg__Range * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // novatel_msg_header
  novatel_gps_msgs__msg__NovatelMessageHeader__fini(&msg->novatel_msg_header);
  // numb_of_observ
  // info
  novatel_gps_msgs__msg__RangeInformation__Sequence__fini(&msg->info);
}

bool
novatel_gps_msgs__msg__Range__are_equal(const novatel_gps_msgs__msg__Range * lhs, const novatel_gps_msgs__msg__Range * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__are_equal(
      &(lhs->novatel_msg_header), &(rhs->novatel_msg_header)))
  {
    return false;
  }
  // numb_of_observ
  if (lhs->numb_of_observ != rhs->numb_of_observ) {
    return false;
  }
  // info
  if (!novatel_gps_msgs__msg__RangeInformation__Sequence__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  return true;
}

bool
novatel_gps_msgs__msg__Range__copy(
  const novatel_gps_msgs__msg__Range * input,
  novatel_gps_msgs__msg__Range * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__copy(
      &(input->novatel_msg_header), &(output->novatel_msg_header)))
  {
    return false;
  }
  // numb_of_observ
  output->numb_of_observ = input->numb_of_observ;
  // info
  if (!novatel_gps_msgs__msg__RangeInformation__Sequence__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  return true;
}

novatel_gps_msgs__msg__Range *
novatel_gps_msgs__msg__Range__create()
{
  novatel_gps_msgs__msg__Range * msg = (novatel_gps_msgs__msg__Range *)malloc(sizeof(novatel_gps_msgs__msg__Range));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__Range));
  bool success = novatel_gps_msgs__msg__Range__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__Range__destroy(novatel_gps_msgs__msg__Range * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__Range__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__Range__Sequence__init(novatel_gps_msgs__msg__Range__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__Range * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__Range *)calloc(size, sizeof(novatel_gps_msgs__msg__Range));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__Range__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__Range__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__Range__Sequence__fini(novatel_gps_msgs__msg__Range__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__Range__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__Range__Sequence *
novatel_gps_msgs__msg__Range__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__Range__Sequence * array = (novatel_gps_msgs__msg__Range__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__Range__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__Range__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__Range__Sequence__destroy(novatel_gps_msgs__msg__Range__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__Range__Sequence__fini(array);
  }
  free(array);
}

bool
novatel_gps_msgs__msg__Range__Sequence__are_equal(const novatel_gps_msgs__msg__Range__Sequence * lhs, const novatel_gps_msgs__msg__Range__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!novatel_gps_msgs__msg__Range__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
novatel_gps_msgs__msg__Range__Sequence__copy(
  const novatel_gps_msgs__msg__Range__Sequence * input,
  novatel_gps_msgs__msg__Range__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(novatel_gps_msgs__msg__Range);
    novatel_gps_msgs__msg__Range * data =
      (novatel_gps_msgs__msg__Range *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!novatel_gps_msgs__msg__Range__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          novatel_gps_msgs__msg__Range__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!novatel_gps_msgs__msg__Range__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
